﻿package  {
	
	import flash.display.MovieClip;
	import flash.display.Sprite; 
	import flash.display.*;
	import flash.text.*;
	import flash.utils.*;
	import flash.events.*;
	import flash.system.*;
	import flash.filters.*;
	import flash.ui.Multitouch;
	import flash.ui.MultitouchInputMode;
	import Shot;
	import Shot2;
	import Enemy;
	import ParallaxField;
	import PixelPerfectCollisionDetection;
	

	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundLoaderContext;
	import flash.media.SoundTransform;
  import flashx.textLayout.formats.BackgroundColor;
	import flashx.textLayout.events.ModelChange;
	import flash.utils.getDefinitionByName;	
	import flash.desktop.NativeApplication;
	import flash.desktop.SystemIdleMode;
	import flash.ui.Keyboard;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.net.SharedObject;

	
	public class AstroBattle extends MovieClip{


	
	
	var spaceShip:MovieClip;
	
	var bProduceEnemies:Boolean = false;
	
	var mcBackground:MovieClip;
	var sndSoundExplosion:SoundExplosion;
	var sndTIE_Fly2:TIE_Fly2;
	var sndTIE_Fly3:TIE_Fly3;
	var sndATST_ChinGuns:ATST_ChinGuns;
	var sndCharge:SeismicCharge;
	var sndSW_Blaster;
	
	var sndBadRomance;
	var sndMusicIsMyLife;
	
	var _channel:SoundChannel;
  var _transform:SoundTransform;

	//
	// CONSTANT
	//
	private const OUT_SCREEN:int = -4000;
	
	private const DELTA_Y_SHIP:uint = 5;
	private const SHOT_VELOCITY:uint = 20;
	private const SHOT2_VELOCITY:uint = 9;
	private const ENENY_VELOCITY:uint=5;
		
	private const SOUNDTRACK_VOLUME:Number = 0.6;

	//
	//game
	//
	private const SEISMIC_CHARGE:uint = 3;
	private const LIFE_NUMBER:uint = 3;
	private const LEVEL_NUMBER:uint = 4;
	private var enemyNumberLevelArr:Array = [0, 45, 60, 75, 90];
	//private var enemyNumberLevelArr:Array = [0, 5, 5, 5, 5];
	
	private const RELOAD_SPEED_BASE:uint = 2200;
	private const ENEMY_PROLIFERATION_BASE:uint = 48;
	

	

	var score_counter:uint = 0;
	var high_score_counter:uint = 0;
	var current_level:uint = 1;
	var life_counter:int = LIFE_NUMBER;  
	var charge_counter:int = SEISMIC_CHARGE;  

	var enemy_proliferation:uint = 0;
	
	private var _counter:Number = 0;
	private var shot_counter:Number = 0;
	private var shot2_counter:Number = 0;
	private var enemy_counter:Number = 0;


	var glow:GlowFilter = new GlowFilter();
	var dropShadow:DropShadowFilter = new DropShadowFilter();

	var fl_PressTimer:Timer = new Timer(20);
	var fr_PressTimer:Timer = new Timer(20);
	
	var resetTimer:Timer = new Timer(3000);
	var clearTimer:Timer = new Timer(2000);
	
	var nextLevelTimer:Timer = new Timer(3000);
	var extechTimer:Timer = new Timer(6000);
	
	
	var reloadTimer:Timer;
	
	private var _textFormat:TextFormat ;
	
	private var parallaxField:ParallaxField;
	private var gameOver:MovieClip;
	private var youWon:MovieClip;
	private var btnPlay:MovieClip;
	private var btnPlay_2:MovieClip;
	private var mcNextLevel:MovieClip;
	private var mcExtech:MovieClip;
	private var mcTheGame:MovieClip;
	//private var mcSeismicExplosion:MovieClip;
	
	
	

	private var _enemyArr:Array = [];
	private var _tmpEnemy:Enemy;
	private var _shotArr:Array = [];
	private var _tmpShot:Shot;
	private var _shot2Arr:Array = [];
	private var _tmpShot2:Shot2;
	
	private var bLoaded:Boolean = false;
	private var _reloadSpeed:Number;
	private var bGameWon:Boolean = false;
	private var bGameOver:Boolean = false;
	private var bWeCanGo:Boolean = false;
	
	
	//
	// screen
	//
	private var _screenDPI:uint;
	private var _screenResolutionX:uint;
	private var _screenResolutionY:uint;

	private var _enemy_limit_y:uint;
	private var _shot_limit_y:uint;
	private var _shot2_limit_y:uint;
		
	private var _delta_game_over:uint;
	private var _delta_play_button:uint;
	
	private var _bmpData:BitmapData;
	private var _bmp:Bitmap;
	private var offset0:Point = new Point();
	private var offset1:Point = new Point(); 

	private var _shared_object:SharedObject = SharedObject.getLocal("astroBattleSharedObjectID");
	
	
	//
	//constructor
	//
	public function AstroBattle() {


		Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;

		this.addEventListener(Event.ENTER_FRAME, enterFrameListener);
		
		_textFormat= new TextFormat();
		_textFormat.color = 0xDDEEDD;
		_textFormat.font = "Helvetica";
		_textFormat.size = 20;
		
		txt_score.setStyle("textFormat", _textFormat);
		txt_high_score.setStyle("textFormat", _textFormat);
		txt_life.setStyle("textFormat", _textFormat);
		txt_level.setStyle("textFormat", _textFormat);
		btn_charge.label.setStyle("textFormat", _textFormat);
		
		
		//graphics.lineStyle(5, 0xff44aa, 0.5);
		//graphics.beginFill(0xFFFF00);
		//graphics.drawCircle(55, 55, 75);
		//graphics.endFill();
		//
		//graphics.drawRoundRect(0, 150, 50, 40, 20, 20);
		//graphics.drawRoundRect(100, 150, 50, 40, 20, 20);
		//
		//graphics.lineStyle(5, 0xff0000, 0.5);


		//
		//graphic entities
		//
		mcNextLevel = new NextLevel();
		mcNextLevel.alpha=0.7;
		addChild(mcNextLevel);
		btnPlay = new PlayButton();
		addChild(btnPlay);
		btnPlay.addEventListener(TouchEvent.TOUCH_TAP, onPlayButtonListener);
		btnPlay.addEventListener(MouseEvent.MOUSE_DOWN, onPlayButtonListener_2);
		//test_1.addEventListener(TouchEvent.TOUCH_TAP, onTest_1);
		
		
		gameOver = new GameOver();
		addChild(gameOver);
		youWon = new YouWon();		
		addChild(youWon);
		
		//mcSeismicExplosion = new SeismicExplosion();
		//addChild(mcSeismicExplosion);
		
		//
		//sound section
		//
		_channel = new SoundChannel();
  	_transform = new SoundTransform();

		sndSoundExplosion = new SoundExplosion();

		sndTIE_Fly2 = new TIE_Fly2();
		sndTIE_Fly3 = new TIE_Fly3();
		sndATST_ChinGuns = new ATST_ChinGuns();
		sndCharge = new SeismicCharge();
		sndSW_Blaster = new SW_Blaster();
		
		sndMusicIsMyLife = new MusicIsMyLife();
		 
		
		mcExtech = new Extech();
		//mcExtech.width = mcExtech.width/(mcExtech.width/stage.stageWidth);
		//mcExtech.height = mcExtech.height/(mcExtech.height/stage.stageHeight);
		
		//showCapabilities();
		addChild(mcExtech);
		extechTimer.addEventListener(TimerEvent.TIMER, onExtechTimer);
		extechTimer.start();

		
		//if(Capabilities.cpuArchitecture!="x86")
		{
			NativeApplication.nativeApplication.addEventListener(Event.ACTIVATE, handleActivate, false, 0, true);
			NativeApplication.nativeApplication.addEventListener(Event.DEACTIVATE, handleDeactivate, false, 0, true);
			NativeApplication.nativeApplication.addEventListener(KeyboardEvent.KEY_DOWN, handleKeys, false, 0, true);
			NativeApplication.nativeApplication.addEventListener(Event.EXITING, onExit);
		}




		//this.stage.scaleMode = StageScaleMode.NO_SCALE;
		this.stage.scaleMode = StageScaleMode.EXACT_FIT;
		this.stage.align = StageAlign.TOP_LEFT;	
		this.stage.addEventListener(Event.RESIZE, doLayout);

		
		_screenDPI = Capabilities.screenDPI;
		_screenResolutionX = Capabilities.screenResolutionX;
		_screenResolutionY = Capabilities.screenResolutionY;


		_enemy_limit_y = _screenResolutionY + 10;
		_shot_limit_y = 0;
		_shot2_limit_y = _enemy_limit_y;
			
		_delta_game_over = 50; //_screenResolutionX/8;
		_delta_play_button = 50; //_screenResolutionX/8;

	
		this.stage.stageWidth = _screenResolutionX;
		this.stage.stageHeight = _screenResolutionY;


	}
	/*
	private function onTest_1(event:Event):void
	{
		NativeApplication.nativeApplication.exit();
	}
	*/
	
	private function doLayout(event:Event):void
	{
		;
	}

	
	private function handleActivate(event:Event):void
	{
		NativeApplication.nativeApplication.systemIdleMode = SystemIdleMode.NORMAL;
	}
	 
	 
	private function handleDeactivate(event:Event):void
	{
		NativeApplication.nativeApplication.exit();
	}
	 
	 
	private function handleKeys(event:KeyboardEvent):void
	{
		if(event.keyCode == Keyboard.BACK)
		NativeApplication.nativeApplication.exit();
		
		
	}
	
	private function onExit(e:Event):void {
		//Code to be executed upon exit.
		NativeApplication.nativeApplication.exit();
		
	}
	

	function onExtechTimer(event:TimerEvent):void
	{
		
		extechTimer.stop();
		extechTimer.removeEventListener(TimerEvent.TIMER, onExtechTimer);
		removeChild(mcExtech);
		
		mcTheGame = new TheGame();
		addChild(mcTheGame);
		
		btnPlay_2 = new PlayButton_2();
		mcTheGame.addChild(btnPlay_2);
		btnPlay_2.x = mcTheGame.width/2 + 100;
		btnPlay_2.y = mcTheGame.height /2 + 120;
				
		btnPlay_2.addEventListener(TouchEvent.TOUCH_TAP, onTheGameButtonListener);
		btnPlay_2.addEventListener(MouseEvent.MOUSE_DOWN, onTheGameButtonListener_2);
	
		
	}


	function onTheGameButtonListener(event:TouchEvent):void
	{
		this.removeChild(mcTheGame);
		preInitGame();
		event.updateAfterEvent();
	}


	function onTheGameButtonListener_2(event:MouseEvent):void
	{
		this.removeChild(mcTheGame);
		preInitGame();
		event.updateAfterEvent();
	}



	
	//------------------------------//
	// methods						//
	//------------------------------//
	
	private function preInitGame() {
		
		
		
		
		parallaxField = new ParallaxField();
		// createField(container, x, y, width, height, numberOfStars, speedX, speedY);
		parallaxField.createField(this, 10, 10, 800, 480, 40, 0.1, 2.0);

		spaceShip = new Spaceship();
		
		this.addChild(spaceShip);
		initGame();
		bWeCanGo = true;

		initGame();
		
		
		
		_bmpData = new BitmapData(40,40,false,0);
		_bmp = new Bitmap(_bmpData);
		exagon_1.addChild(_bmp);
		
	}
	
	
	private function initGame() {
		

		spaceShip.cacheAsBitmap=true; 
		//
		//sounds
		//
		_channel.stop();
		_channel = sndMusicIsMyLife.play(0, 1000);
		_transform.volume = SOUNDTRACK_VOLUME;
		_channel.soundTransform = _transform;

                
		bGameWon = false;
		bGameOver = false;
		current_level = 1;
		score_counter = 0;
		high_score_counter = _shared_object.data.highScore;
		
		life_counter = LIFE_NUMBER;  
		charge_counter = SEISMIC_CHARGE;
		enemy_counter = 0;
		_counter = 0;


		removeChildAt(0);
		var ClassReference:Class = getDefinitionByName("Backgroung_Space_" + current_level) as Class;
		mcBackground = new ClassReference();
		//mcBackground.width = _screenResolutionX;
		//mcBackground.height = _screenResolutionY;
		this.addChildAt(mcBackground, 0);

				
		exagon_1.x = exagon_1.y = -100;
		
	  gameOver.x = gameOver.y = OUT_SCREEN;

		btnPlay.x = btnPlay.y = OUT_SCREEN;
		
		youWon.x = youWon.y = OUT_SCREEN;
		
		mcNextLevel.x = mcNextLevel.y = OUT_SCREEN;
		
		//mcSeismicExplosion.x = mcSeismicExplosion.y = OUT_SCREEN; 

		
		/*			
		if( (null!=gameOver) && (gameOver.visible==true))
		{ this.removeChild(gameOver); }
		
		if( (null!=btnPlay) && (btnPlay.visible==true))
		{ this.removeChild(btnPlay); }
		
		if( (null!=youWon) && (youWon.visible==true))
		{ this.removeChild(youWon); }

		if( (null!=mcNextLevel) && (mcNextLevel.visible==true))
		{ this.removeChild(mcNextLevel); }
		*/
		
		
		//enemy can fire
		bLoaded=true;
		
		_reloadSpeed = Math.ceil(RELOAD_SPEED_BASE-current_level*200);
		enemy_proliferation = Math.ceil( ENEMY_PROLIFERATION_BASE/(1 + (2*current_level/10)) );
		
		clearDisplay();
		resetSpaceShip();
		enableCommands();
		
		
	}
	
	
	private function resetSpaceShip() {
		
		spaceShip.x = stage.stageWidth/2;
		spaceShip.y = stage.stageHeight-120;
		
		fl_PressTimer.stop();
		fr_PressTimer.stop();
		
	}
		
		
	private function disableCommands() {
		
		fl_PressTimer.removeEventListener(TimerEvent.TIMER, fl_PressTimerHandler);
		fr_PressTimer.removeEventListener(TimerEvent.TIMER, fr_PressTimerHandler);

		btn_left.removeEventListener(TouchEvent.TOUCH_BEGIN, fl_PressBeginHandler);
		btn_left.removeEventListener(TouchEvent.TOUCH_END, fl_PressEndHandler);
		btn_right.removeEventListener(TouchEvent.TOUCH_BEGIN, fr_PressBeginHandler);
		btn_right.removeEventListener(TouchEvent.TOUCH_END, fr_PressEndHandler);
		btn_fire.removeEventListener(TouchEvent.TOUCH_TAP, fl_TapHandler_fire);
		btn_charge.removeEventListener(TouchEvent.TOUCH_TAP, onButtonChargeHandler);
		
		stage.removeEventListener(KeyboardEvent.KEY_DOWN, fl_KeyboardDownHandler);
		stage.removeEventListener(KeyboardEvent.KEY_UP, fl_KeyboardUpHandler);
		
		
	}
	

	private function enableCommands() {

		fl_PressTimer.addEventListener(TimerEvent.TIMER, fl_PressTimerHandler);
		fr_PressTimer.addEventListener(TimerEvent.TIMER, fr_PressTimerHandler);

		btn_left.addEventListener(TouchEvent.TOUCH_BEGIN, fl_PressBeginHandler);
		btn_left.addEventListener(TouchEvent.TOUCH_END, fl_PressEndHandler);
		btn_right.addEventListener(TouchEvent.TOUCH_BEGIN, fr_PressBeginHandler);
		btn_right.addEventListener(TouchEvent.TOUCH_END, fr_PressEndHandler);
		btn_fire.addEventListener(TouchEvent.TOUCH_TAP, fl_TapHandler_fire);
		btn_charge.addEventListener(TouchEvent.TOUCH_TAP, onButtonChargeHandler);
		
		stage.addEventListener(KeyboardEvent.KEY_DOWN, fl_KeyboardDownHandler);
		stage.addEventListener(KeyboardEvent.KEY_UP, fl_KeyboardUpHandler);
	}

		
		
	

	function onClearTimer(event:TimerEvent):void
	{
		clearTimer.stop();
		clearTimer.removeEventListener(TimerEvent.TIMER, onClearTimer);
		
		bProduceEnemies=true;
	}
	
	
	private function clearDisplay() {
		
		bProduceEnemies=false;
		for(var a:int = 0; a < _enemyArr.length; ++a)
		{ 
			_tmpEnemy = _enemyArr[a] as Enemy;
			this.removeChild(_tmpEnemy);
		}
		_enemyArr.splice(0);
		//trace("_enemyArr.length: " + _enemyArr.length);
		
		for(var b:int = 0; b < _shotArr.length; ++b)
		{ 
			_tmpShot = _shotArr[b] as Shot;
			this.removeChild(_tmpShot);
		}
		_shotArr.splice(0);
		
		for(var c:int = 0; c < _shot2Arr.length; ++c)
		{ 
			_tmpShot2 = _shot2Arr[c] as Shot2;
			this.removeChild(_tmpShot2);
		}
		_shot2Arr.splice(0);
				
		
		clearTimer.addEventListener(TimerEvent.TIMER, onClearTimer);
		clearTimer.start();
	}


	private function clearDisplayNoPause() {
		
		for(var a:int = 0; a < _enemyArr.length; ++a)
		{ 
			_tmpEnemy = _enemyArr[a] as Enemy;
			this.removeChild(_tmpEnemy);
		}
		_enemyArr.splice(0);

		for(var b:int = 0; b < _shotArr.length; ++b)
		{ 
			_tmpShot = _shotArr[b] as Shot;
			this.removeChild(_tmpShot);
		}
		_shotArr.splice(0);
		
		for(var c:int = 0; c < _shot2Arr.length; ++c)
		{ 
			_tmpShot2 = _shot2Arr[c] as Shot2;
			this.removeChild(_tmpShot2);
		}
		_shot2Arr.splice(0);
		
	}


	
	private function reset() {
		
		if(life_counter>1) {
			
			//if(spaceShip!=null) {
			//	this.removeChild(spaceShip);
			//}
			spaceShip.x = spaceShip.y = -1000;
			disableCommands();
			
			
			--life_counter
			resetTimer.addEventListener(TimerEvent.TIMER, onResetTimer);
			resetTimer.start();
			
		} else {
			
			doGameOver();
		}
	}


	function onResetTimer(event:TimerEvent):void
	{
		resetTimer.stop();
		resetTimer.removeEventListener(TimerEvent.TIMER, onResetTimer);
		
		clearDisplay();
		resetSpaceShip();
		enableCommands();
	
	}

	
	private function doGameOver() {

		//
		//game over
		//
		bGameOver=true;
		
		life_counter=0;
		
		spaceShip.x = spaceShip.y = -1000;
		
		bProduceEnemies=false;
		disableCommands();
		
		var maxIndex:Number = this.numChildren - 1;
		//gameOver = new GameOver();
		//btnPlay = new PlayButton();
		
		setChildIndex(gameOver, maxIndex);
		gameOver.x = _delta_game_over; //(this.stage.stageWidth-gameOver.width)/2 - _delta_game_over;
		gameOver.y = (this.stage.stageHeight-gameOver.height)/2;
				
		setChildIndex(btnPlay, maxIndex);
		btnPlay.x = gameOver.x + gameOver.width +_delta_play_button;
		btnPlay.y = gameOver.y;
		//btnPlay.addEventListener(TouchEvent.TOUCH_TAP, onPlayButtonListener);
		//btnPlay.addEventListener(MouseEvent.MOUSE_DOWN, onPlayButtonListener_2);

	}
	
	
	
	private function doGameWon() {

		//
		//game won
		//
		bGameWon=true;
		life_counter=0;
		
		spaceShip.x = spaceShip.y = -1000;
		
		bProduceEnemies=false;
		disableCommands();
		//clearDisplayNoPause();
		
		var maxIndex:Number = this.numChildren - 1;
		//youWon = new YouWon();
		//btnPlay = new PlayButton();
		
		setChildIndex(youWon, maxIndex);;
		youWon.x = _delta_game_over; //(this.stage.stageWidth-youWon.width)/2 - _delta_game_over;
		youWon.y = (this.stage.stageHeight-youWon.height)/2;
		
		setChildIndex(btnPlay, maxIndex);
		btnPlay.x = youWon.x + youWon.width + _delta_play_button;
		btnPlay.y = youWon.y;
		//btnPlay.addEventListener(TouchEvent.TOUCH_TAP, onPlayButtonListener);
		//btnPlay.addEventListener(MouseEvent.MOUSE_DOWN, onPlayButtonListener_2);
		
	}
	

	function onPlayButtonListener(event:TouchEvent):void
	{
		initGame();
		event.updateAfterEvent();
	}

	function onPlayButtonListener_2(event:MouseEvent):void
	{
		initGame();
		event.updateAfterEvent();
	}


	


	private function createEnemy():void
	{
		_tmpEnemy = new Enemy("enemy" + enemy_counter, 1, (ENENY_VELOCITY +(2*current_level/5))  );
		_tmpEnemy.cacheAsBitmap=true;
		_enemyArr.push(_tmpEnemy);
		this.addChild(_tmpEnemy);
		++enemy_counter;
	}
	

	private function destroyEnemy(enemy:Enemy):void
	{
		// loop through array
		for(var i:int = 0; i < _enemyArr.length; i++)
		{
			// save a reference to current 
			_tmpEnemy = _enemyArr[i] as Enemy;
			
			// if found bullet in array
			if(_tmpEnemy == enemy)
			{
				// remove from array
				_enemyArr.splice(i, 1);
				
				// remove from display list
				this.removeChild(enemy);
								
				// stop loop
				return;
			}
		}
	}
	
	
	private function updateEnemy():void
	{
		// loop through  array
		for (var i:int = 0; i < _enemyArr.length; i++)
		{
			_tmpEnemy = _enemyArr[i] as Enemy;
			
			if(_tmpEnemy.y > _enemy_limit_y)
			{
				destroyEnemy(_tmpEnemy);
			} else if (checkCollision(_tmpEnemy))
			{
				destroyEnemy(_tmpEnemy);
				
			}

		}
	}
	
	
	private function checkCollision(enemy:Enemy):Boolean
	{
		// if nothing to check against, abort
		//if (_shotArr.length == 0) return false;
		
		// loop through array
		for (var i:int = 0; i < _shotArr.length; i++)
		{
			// save a reference to current object
			_tmpShot = _shotArr[i] as Shot;
			
			// do a hit test
			//if(PixelPerfectCollisionDetection.getCollisionRect(_tmpShot, 
      //                                                    enemy, 
      //                                                    this, 
      //                                                    true, 
      //                                                    1))
      //																										
			if (_tmpShot.hitTestObject(enemy))
			{
				destroyShot(_tmpShot);
				score_counter += 100;
				if(score_counter>high_score_counter)
				{
					high_score_counter = score_counter;
					_shared_object.data.highScore = high_score_counter;
					_shared_object.flush();
					
				}
				
				var explosion_2:Explosion = new Explosion();
				explosion_2.x = _tmpShot.x;
				explosion_2.y = _tmpShot.y;
				addChild(explosion_2);
				//sound of explosion
				sndSoundExplosion.play(); 
				
				
				
				return true;
			}
		}
		
		
		//if(PixelPerfectCollisionDetection.getCollisionRect(spaceShip, 
    //                                                   enemy, 
    //                                                   this, 
    //                                                   true, 
    //                                                   1))
		if( enemy.hitTestObject(spaceShip) ) 
		{
			var explosion:Explosion = new Explosion();
			addChild(explosion);
			explosion.x = spaceShip.x;
			explosion.y = spaceShip.y;
			//sound of explosion
			sndSoundExplosion.play();
			reset();
			
			return true;
		}
		
		return false;
	}
	
	
	private function createShot():void
	{
		_tmpShot = new Shot("shot" + (++shot_counter), spaceShip.x, spaceShip.y + DELTA_Y_SHIP, SHOT_VELOCITY);
		_tmpShot.cacheAsBitmap=true;
		_shotArr.push(_tmpShot);
		this.addChild(_tmpShot);
	}
	

	private function destroyShot(shot:Shot):void
	{
		// loop through array
		for(var i:int = 0; i < _shotArr.length; i++)
		{
			// save a reference to current 
			_tmpShot = _shotArr[i] as Shot;
			
			// if found bullet in array
			if(_tmpShot == shot)
			{
				// remove from array
				_shotArr.splice(i, 1);
				
				// remove from display list
				this.removeChild(shot);
								
				// stop loop
				return;
			}
		}
	}
	
	
	private function updateShot():void
	{
		// loop through  array
		for (var i:int = 0; i < _shotArr.length; i++)
		{
			_tmpShot = _shotArr[i] as Shot;
			
			if(_tmpShot.y < _shot_limit_y )
			{
				destroyShot(_tmpShot);
			} 
		}
	}	


	private function createShot2(x:int, y:int, velocity:int):void
	{
		_tmpShot2 = new Shot2("shot2" + (++shot2_counter), x, y, velocity);
		_tmpShot2.cacheAsBitmap=true;
		_shot2Arr.push(_tmpShot2);
		this.addChild(_tmpShot2);
		sndSW_Blaster.play();
	}
	

	private function destroyShot2(shot2:Shot2):void
	{
		// loop through array
		for(var i:int = 0; i < _shot2Arr.length; i++)
		{
			// save a reference to current 
			_tmpShot2 = _shot2Arr[i] as Shot2;
			
			// if found bullet in array
			if(_tmpShot2 == shot2)
			{
				// remove from array
				_shot2Arr.splice(i, 1);
				
				// remove from display list
				this.removeChild(shot2);
								
				// stop loop
				return;
			}
		}
	}
	
	
	private function updateShot2():void
	{
		// loop through  array
		for (var i:int = 0; i < _shot2Arr.length; i++)
		{
			_tmpShot2 = _shot2Arr[i] as Shot2;
			
			if(_tmpShot2.y > _shot2_limit_y ) {
				destroyShot2(_tmpShot2);
			} else if (checkCollision2(_tmpShot2)) {
				destroyShot2(_tmpShot2);
			}
		}
	}	

	private function checkCollision2(shot2:Shot2):Boolean
	{
		
		// loop through array
		for (var i:int = 0; i < _shot2Arr.length; i++)
		{
			_tmpShot2 = _shot2Arr[i] as Shot2;
			
			// do a hit test
			if (_tmpShot2.hitTestObject(spaceShip))
			{
				var explosion:Explosion = new Explosion();
				addChild(explosion);
				explosion.x = spaceShip.x;
				explosion.y = spaceShip.y;
				//sound of explosion
				sndSoundExplosion.play();
				reset();
				
				return true;
			}
		}
		
		return false;
	}
	
	
	
	private function doEnemyFiring(level:uint):void
	{

		var enemy_id:uint;
		var tmpEnemy:Enemy=null;
		
		//trace(""+enemy_id);

		// check if reloaded
		if (!bLoaded) return;
		
		for (var a:uint = 0; a< level; a++)
		{
			enemy_id = Math.ceil(Math.random() * _enemyArr.length);
			tmpEnemy = _enemyArr[enemy_id] as Enemy;
			if(tmpEnemy!=null) {
				createShot2(tmpEnemy.x, tmpEnemy.y, SHOT2_VELOCITY);
			}
			
		}
		
		// start reload timer
		reloadTimer = new Timer(_reloadSpeed);
		reloadTimer.addEventListener(TimerEvent.TIMER, reloadTimerHandler);
		reloadTimer.start();
		
		// set reload flag to false
		bLoaded = false;
		
		
	}


	private function reloadTimerHandler(e:TimerEvent):void 
	{
		// stop timer
		e.target.stop();
		
		// clear timer var
		reloadTimer = null;
	 
		bLoaded = true;
	}


	private function updateLevel():void {

		trace("---------------------------------");			
		trace("current_level " + current_level);			
		trace("enemy_counter " + enemy_counter);			
		trace("_counter " + _counter);
		trace("_enemyArr.length " + _enemyArr.length);
		trace("---------------------------------");		
	
		//we make the action only there aren't been either the game_over or the game_won event 
		if( !(bGameOver || bGameWon) )
		{
			
			//check the current level is minor that max level allowed
			if(current_level<=LEVEL_NUMBER) {

				//produce enemies only if the enemy counter is not greater then the max enemy allowed per level and
				//the number of enemies on the screen is zero taht is _enemyArr.length=0
				if( !( (enemy_counter>=enemyNumberLevelArr[current_level]) && (_enemyArr.length==0) ) ) 
				{
					//bProduceEnemies is a global boolean variable for enemies production;
					//_counter%enemy_proliferation is the rate for  enemies production;
					//enemy_counter<enemyNumberLevelArr[current_level], with this check the number of enemies allowed must
					//be less then the enemies per level
					if( bProduceEnemies && (_counter%enemy_proliferation==0) && (enemy_counter<enemyNumberLevelArr[current_level]) ) {
						createEnemy();
					}
			
				} 
				else 
				{
					
					trace("updateLevel() --------current_level " + current_level + "  --- nextLevel() calling ....");
					
					if(current_level<LEVEL_NUMBER) {
						//mcNextLevel = new NextLevel();
						//addChildAt(mcNextLevel, numChildren-1); 
						mcNextLevel.x = stage.stageWidth/2;
						mcNextLevel.y = stage.stageHeight/2;
					}	
					nextLevelTimer.addEventListener(TimerEvent.TIMER, onNextLevelTimer);
					nextLevelTimer.start();
					
				} 
			
			}
		}

	}


	function onNextLevelTimer(event:TimerEvent):void
	{
		nextLevelTimer.stop();
		nextLevelTimer.removeEventListener(TimerEvent.TIMER, onNextLevelTimer);
		
		event.updateAfterEvent();
		nextLevel();
	}
		

	private function nextLevel():void {
	

		//if( (null!=mcNextLevel) && (mcNextLevel.visible==true))
		//{ this.removeChild(mcNextLevel); }
		mcNextLevel.x = mcNextLevel.y = -1000;
		
		++current_level;

		if(current_level>LEVEL_NUMBER) {
			doGameWon();
		} else {
			
			
			removeChildAt(0);
			var ClassReference:Class = getDefinitionByName("Backgroung_Space_" + current_level) as Class;
			mcBackground = new ClassReference();
			//mcBackground.width = _screenResolutionX;
			//mcBackground.height = _screenResolutionY;
			this.addChildAt(mcBackground,0);
			
			
			
			enemy_counter = 0;
			_counter = 0;
			disableCommands();
			
			_reloadSpeed = Math.ceil(RELOAD_SPEED_BASE-current_level*200);
			enemy_proliferation = Math.ceil( ENEMY_PROLIFERATION_BASE/(1 + (2*current_level/10)) );
			
			clearDisplay();
			resetSpaceShip();
			enableCommands();


		}
		
	}


			
	private function enterFrameListener (e:Event):void {



		if(bWeCanGo)
		{
				
				++_counter;
				txt_score.text  = "score: " + score_counter ;
				txt_high_score.text  = "high score: " + high_score_counter ;
				txt_life.text = "ship: " + life_counter;
				if(bGameWon) {
					txt_level.text = "level: " + LEVEL_NUMBER;
				} else {
					txt_level.text = "level: " + current_level;
				}
				
				btn_charge.label.text = "" + charge_counter;
				
				////glow.color = 0xFFFFFF;
				////glow.strength = 10;
				//offset0.y +=  .5;
				//offset0.x +=  .5;
				//offset1.y -=  .5;
				//offset1.x -=  .5;
				//_bmpData.perlinNoise(150, 150, 3, 1, true, false, 2, false, [offset0, offset1]);
				//exagon_1.x += 1;
				//exagon_1.y += 0.4;
				////exagon_1.alpha = Math.sin((_counter%48)*(Math.PI/48))-0.1;
				//exagon_1.rotation += 2;
				////exagon_1.filters = [glow, dropShadow];
				
				
				setChildIndex(btn_left, numChildren-1);
				setChildIndex(btn_right, numChildren-1);
				setChildIndex(btn_fire, numChildren-1);
				setChildIndex(btn_charge, numChildren-1);
				setChildIndex(txt_score, numChildren-1);
				setChildIndex(txt_high_score, numChildren-1);
				setChildIndex(txt_life, numChildren-1);
				setChildIndex(txt_level, numChildren-1);
				
			
				if( (null!=spaceShip) && (true==spaceShip.visible) ) {
					setChildIndex(spaceShip, numChildren-1);
				}
	
				updateLevel();
				updateEnemy();
				updateShot();
				doEnemyFiring(current_level);
				updateShot2();
			
				trace("enterFrameListener ---  children: " + numChildren);
				
				//			samuel_1.x += 7;
				//			samuel_1.y += 0.5;
				//			
				//			if(samuel_1.x > 800)
				//			{ samuel_1.x=0; }
							
				//			if( samuel_1.hitTestObject(exagon_1) ) {
				//				//trace("hit " + exagon_1);
				//				++score_counter;
				//				txt_score.text  = " " + score_counter ;
				//				graphics.drawCircle(50, 400, score_counter);
				//				
				//			}
				
			}
		}//enterFrameListener
		

		function fl_KeyboardDownHandler(event:KeyboardEvent):void
		{
			//trace("Key Code Pressed: " + event.keyCode);

			if (event.keyCode== 90) //Z)
			{
				onButtonChargeHandler(null);
			}

			if (event.keyCode== 39) //Key.RIGHT)
			{
				btn_right.dispatchEvent(new TouchEvent(TouchEvent.TOUCH_BEGIN));
				//fr_PressTimerHandler(null);
				
			} else if (event.keyCode== 37) //Key.LEFT))
			{
				btn_left.dispatchEvent(new TouchEvent(TouchEvent.TOUCH_BEGIN));
				//fl_PressTimerHandler(null);
				
			} else if (event.keyCode== 38) //Key.UP))
			{
				spaceShip.y -= 10;
				
			} else if  (event.keyCode== 40) //Key.DOWN))
			{
				spaceShip.y += 10;
				
			} else if  (event.keyCode== 32) //Key.SPACE))
			{
				//	createShot();
				//	sndATST_ChinGuns.play();
				
				btn_fire.dispatchEvent(new TouchEvent(TouchEvent.TOUCH_TAP));
			}

		}


		function fl_KeyboardUpHandler(event:KeyboardEvent):void
		{
			//trace("Key Code Pressed: " + event.keyCode);


			if (event.keyCode== 39) //Key.RIGHT)
			{
				btn_right.dispatchEvent(new TouchEvent(TouchEvent.TOUCH_END));
				//fr_PressTimerHandler(null);
				
			} else if (event.keyCode== 37) //Key.LEFT))
			{
				btn_left.dispatchEvent(new TouchEvent(TouchEvent.TOUCH_END));
				//fl_PressTimerHandler(null);
				
			} else if (event.keyCode== 38) //Key.UP))
			{
				spaceShip.y -= 10;
				
			} else if  (event.keyCode== 40) //Key.DOWN))
			{
				spaceShip.y += 10;
				
			} 

		}
		
		

		
		

		
		function fl_TapHandler_fire(event:TouchEvent):void
		{
			createShot();
			sndATST_ChinGuns.play();
			event.updateAfterEvent();
		}


		function onButtonChargeHandler(event:TouchEvent):void
		{
			if(charge_counter>0) {
				
				sndCharge.play();
				var mcSeismicExplosion:SeismicExplosion = new SeismicExplosion();
				addChild(mcSeismicExplosion);
				mcSeismicExplosion.x = stage.stageWidth/2; 
				mcSeismicExplosion.y = stage.stageHeight/2;
				sndCharge.play();
								
				clearDisplayNoPause();
				--charge_counter;
				
				if(event!=null)
				{ event.updateAfterEvent(); }
				
			}
		}


		function fl_PressTimerHandler(event:TimerEvent):void
		{
			if(spaceShip.x>5)
			{spaceShip.x -= 10;}
			//sndTIE_Fly2.play();
			
			if(event!=null)
			{ event.updateAfterEvent(); }
		}

		function fl_PressBeginHandler(event:TouchEvent):void
		{
			fl_PressTimer.stop();
			fr_PressTimer.stop();

			fl_PressTimer.start();
		}
		
		function fl_PressEndHandler(event:TouchEvent):void
		{
			fl_PressTimer.stop();
		}



		function fr_PressTimerHandler(event:TimerEvent):void
		{
			if(spaceShip.x<795)
			{ spaceShip.x += 10;}
			//sndTIE_Fly3.play();
			
			if(event!=null)
			{ event.updateAfterEvent(); }
		}

		function fr_PressBeginHandler(event:TouchEvent):void
		{
			fl_PressTimer.stop();
			fr_PressTimer.stop();
			
			fr_PressTimer.start();
		}
		
		function fr_PressEndHandler(event:TouchEvent):void
		{
			fr_PressTimer.stop();
		}



		private function showCapabilities():void {
	    var tf:TextField = new TextField();
	    tf.height = 480;
	    tf.width = 800;
	    
	    tf.background = true;
	    tf.backgroundColor = 0xFFFFFF;
	    tf.autoSize = TextFieldAutoSize.LEFT;
	    tf.wordWrap = true;
            
      tf.text = "avHardwareDisable: " + Capabilities.avHardwareDisable +
		            "\nhasAccessibility: " + Capabilities.hasAccessibility +
		            "\nhasAudio: " + Capabilities.hasAudio +
		            "\nhasAudioEncoder: " + Capabilities.hasAudioEncoder +
		            "\nhasEmbeddedVideo: " + Capabilities.hasEmbeddedVideo +
		            "\nhasIME: " + Capabilities.hasIME +
		            "\nhasMP3: " + Capabilities.hasMP3 +
		            "\nhasPrinting: " + Capabilities.hasPrinting +
		            "\nhasScreenBroadcast: " + Capabilities.hasScreenBroadcast +
		            "\nhasScreenPlayback: " + Capabilities.hasScreenPlayback +
		            "\nhasStreamingAudio: " + Capabilities.hasStreamingAudio +
		            "\nhasStreamingVideo: " + Capabilities.hasStreamingVideo +
		            "\nhasTLS: " + Capabilities.hasTLS +
		            "\nhasVideoEncoder: " + Capabilities.hasVideoEncoder +
		            "\nisDebugger: " + Capabilities.isDebugger +
		            "\nisEmbeddedInAcrobat: " + Capabilities.isEmbeddedInAcrobat +
		            "\nlanguage: " + Capabilities.language +
		            "\nlocalFileReadDisable: " + Capabilities.localFileReadDisable +
		            "\nmanufacturer: " + Capabilities.manufacturer +
		            "\nmaxLevelIDC: " + Capabilities.maxLevelIDC +
		            "\nos: " + Capabilities.os +
		            "\npixelAspectRatio: " + Capabilities.pixelAspectRatio +
		            "\nplayerType: " + Capabilities.playerType +
		            "\nscreenColor: " + Capabilities.screenColor +
		            "\nscreenDPI: " + Capabilities.screenDPI +
		            "\nscreenResolutionX: " + Capabilities.screenResolutionX +
		            "\nscreenResolutionY: " + Capabilities.screenResolutionY +
		            "\nserverString: " + Capabilities.serverString +
		            "\ntouchscreenType: " + Capabilities.touchscreenType +
		            "\nversion: " + Capabilities.version +
		            // The following capabilities are supported only when publishing for AIR.
		            // If you are publishing for AIR, uncomment the following lines.
		            "\nlanguages: " + Capabilities.languages +
		            "\ncpuArchitecture: " + Capabilities.cpuArchitecture +
		            "\nsupports32BitProcesses: " + Capabilities.supports32BitProcesses +
		            "\nsupports64BitProcesses: " + Capabilities.supports64BitProcesses;   
			                            
                
			addChild(tf);   
                
            //trace("avHardwareDisable: " + Capabilities.avHardwareDisable);
            //trace("hasAccessibility: " + Capabilities.hasAccessibility);
            //trace("hasAudio: " + Capabilities.hasAudio);
            //trace("hasAudioEncoder: " + Capabilities.hasAudioEncoder);
            //trace("hasEmbeddedVideo: " + Capabilities.hasEmbeddedVideo);
            //trace("hasIME: " + Capabilities.hasIME);
            //trace("hasMP3: " + Capabilities.hasMP3);
            //trace("hasPrinting: " + Capabilities.hasPrinting);
            //trace("hasScreenBroadcast: " + Capabilities.hasScreenBroadcast);
            //trace("hasScreenPlayback: " + Capabilities.hasScreenPlayback);
            //trace("hasStreamingAudio: " + Capabilities.hasStreamingAudio);
            //trace("hasStreamingVideo: " + Capabilities.hasStreamingVideo);
            //trace("hasTLS: " + Capabilities.hasTLS);
            //trace("hasVideoEncoder: " + Capabilities.hasVideoEncoder);
            //trace("isDebugger: " + Capabilities.isDebugger);
            //trace("isEmbeddedInAcrobat: " + Capabilities.isEmbeddedInAcrobat);
            //trace("language: " + Capabilities.language);
            //trace("localFileReadDisable: " + Capabilities.localFileReadDisable);
            //trace("manufacturer: " + Capabilities.manufacturer);
            //trace("maxLevelIDC: " + Capabilities.maxLevelIDC);
            //trace("os: " + Capabilities.os);
            //trace("pixelAspectRatio: " + Capabilities.pixelAspectRatio);
            //trace("playerType: " + Capabilities.playerType);
            //trace("screenColor: " + Capabilities.screenColor);
            //trace("screenDPI: " + Capabilities.screenDPI);
            //trace("screenResolutionX: " + Capabilities.screenResolutionX);
            //trace("screenResolutionY: " + Capabilities.screenResolutionY);
            //trace("serverString: " + Capabilities.serverString);
            //trace("touchscreenType: " + Capabilities.touchscreenType);
            //trace("version: " + Capabilities.version);
            
            // The following capabilities are supported only when publishing for AIR.
            // If you are publishing for AIR, uncomment the following lines.       
            //trace("cpuArchitecture: " + Capabilities.cpuArchitecture);
            //trace("languages: " + Capabilities.languages);
            //trace("supports32BitProcesses: " + Capabilities.supports32BitProcesses);
            //trace("supports64BitProcesses: " + Capabilities.supports64BitProcesses);        
       
        }


				/**
				 * Convert inches to pixels.
				 */
				private function inchesToPixels(inches:Number):uint
				{
				   return Math.round(Capabilities.screenDPI * inches);
				}


				/**
				 * Convert millimeters to pixels.
				 */
				private function mmToPixels(mm:Number):uint
				{
				   return Math.round(Capabilities.screenDPI * (mm / 25.4));
				}


				/**
				 * Center one DisplayObject relative to another.
				 */
				private function center(foreground:DisplayObject,
				   background:DisplayObject):void
				   {
				      foreground.x = (background.width / 2) -
				         (foreground.width / 2);
				      foreground.y = (background.height / 2) +
				         (foreground.height / 2);
				   }


	}// class AstroBattle


}//package
